<template>
  <div class="style__cutPage">
    <!-- Navegador -->
    <!-- Cuerpo -->
    <div class="padding-top">
      <el-header height="110px" style="margin: 0 10rem;">
        <!-- Regresar a lista de materiales CON modal -->
        <ReturnButton v-if="!disableCreateButton" v-on:clickEvent="returnButtonModal = true" title="Ir a Materiales" :offsetArrow="20" :spanTitle="3" class="text-end"></ReturnButton>
        <!-- Regresar a lista de materiales SIN modal -->
        <ReturnButton v-else v-on:clickEvent="viewListMaterials" title="Ir a Materiales" :offsetArrow="20" :spanTitle="3" class="text-end"></ReturnButton>
        <!-- Modal botón regresar-->
        <AppModalReturn :show-dialog.sync="returnButtonModal" v-if="returnButtonModal" v-on:btnEvent="returnButtonModal = false" @btnEvent="viewListMaterials" v-on:eventBtn="returnButtonModal = false">
        </AppModalReturn>

        <div class="titleSection">{{ material.listTitle }}</div>
      </el-header>
      <el-main style="margin: 3rem 12rem">
        <!-- Material con capítulos -->
        <div v-if="material.numChapters && material.numChapters.length > 0">
          <!-- Temporadas -->
          <!-- Cantidad de capítulos según la temporada -->
          <div class="bg-light-red fonts-bold-general" style="padding: 0.5rem 1.5rem; margin: 3rem 0.5rem;">
            CAPÍTULOS DE LA TEMPORADA {{material.videoCutting[chooseSeason - 1].season}}:
            <span style="margin-left: 1rem">{{material.videoCutting[chooseSeason - 1].chapters}}</span>
          </div>
          <el-tabs v-model="activeName" type="card" class="tabContentStyle" style="margin-top: 3rem" >
            <!-- Todos los capítulos -->
            <el-tab-pane name="allChapters" label="TODOS LOS CAPÍTULOS" class="tabMargin">
              <!-- CORTES -->
              <h4 class="text-orange">CORTES DEL MATERIAL:</h4>

              <el-row style="margin: 0 0 0 0" v-show="isCodM">
                <template v-if="supportData && supportData.length > 1">
                  <el-col :span="6">
                    <p class="fonts-bold-general" style="margin-top: 7px">Seleccionar Capítulo:</p>
                  </el-col>
                  <el-col :span="6">
                    <app-select v-model="selectChapter" :filterArray="getChapters"></app-select>
                  </el-col>
                </template>
                <template v-if="rolls.length>0">
                  <el-col :span="6">
                    <p class="fonts-bold-general" style="margin-top: 7px">Seleccionar Rollo:</p>
                  </el-col>
                  <el-col :span="6">
                    <app-select v-model="selectRoll" :filterArray="rolls"></app-select>
                  </el-col>
                </template>
                
              </el-row>

              <!-- Duración artística -->
              <el-row v-if="material.videoCutting" style="margin: 2rem 0" type="flex" align="middle">
                <el-col :span="12">
                  <el-row type="flex" align="middle">
                    <el-col :span="10">
                      <p class="fonts-bold-general">Duración Artística:</p>
                    </el-col>
                    <el-col :span="7">
                      <el-input v-if="material.videoCutting[chooseSeason - 1].allChapters.cuts.length > 0" v-model="material.videoCutting[chooseSeason - 1].allChapters.artisticDuration" type="time" step="2" size="small" :disabled="true"></el-input>
                      <el-input v-else v-model="material.videoCutting[chooseSeason - 1].artisticDuration" type="time" step="2" size="small" :disabled="true"></el-input>
                    </el-col>
                  </el-row>
                </el-col>
              </el-row>
              <!-- Factores para crear Cortes -->
              <el-row style="margin: 0 0 3rem 0">
                <el-col :span="12">
                  <p class="fonts-bold-general" style="margin-bottom: 1rem">Ingresa el Número de Cortes:</p>
                  <el-col :span="14" class="bg-gray" style="padding: 6px 1rem">
                    <el-col :span="14" class="fonts-bold-general" style="margin-top: 6px">N° de Cortes:</el-col>
                    <el-col :span="7"><el-input v-model="numberOfCuts" maxlength="3" size="small" @keyup.enter.native="$refs.jump1.focus" v-on:keypress.native="isNumber"
                    @focus="isShowModal('allChapters')"></el-input></el-col>
                  </el-col>
                </el-col>
                <el-col :span="12">
                  <p class="fonts-bold-general" style="margin-bottom: 1rem">Ingresa la Duración de los Cortes:</p>
                  <el-col :span="16" class="bg-gray" style="padding: 6px 1rem">
                    <el-col :span="16" class="fonts-bold-general" style="margin-top: 6px">Tiempo de Cortes:</el-col>
                    <el-col :span="6"><el-input v-model="timeOfCut" maxlength="2" size="small" ref="jump1" @keyup.enter.native.prevent="makeCuts(chooseSeason, timeOfCut)" @focus="isShowModal('allChapters')" v-on:keypress.native="isNumber"></el-input></el-col>                
                  </el-col>
                </el-col>
              </el-row>
              <!-- Creando Cortes -->
              <el-row v-if="material.videoCutting">
                <el-col :span="18" v-show="material.videoCutting && material.videoCutting[chooseSeason - 1].allChapters.cuts.length > 0" style="margin-bottom:1.2rem">
                  <el-col :span="2" class="fonts-bold-general">Corte:</el-col>
                  <el-col :span="5" :offset="1" class="fonts-bold-general">T.C. Inicio:</el-col>
                  <el-col :span="5" :offset="1" class="fonts-bold-general">Duración:</el-col>
                  <el-col :span="5" :offset="1" class="fonts-bold-general">T.C. Fin:</el-col>
                </el-col>
                <el-col :span="18" v-for="(cutTime, index) in material.videoCutting[chooseSeason - 1].allChapters.cuts" style="margin-bottom: 0.6rem"
                  :id="index" :key="index">
                  <el-col :span="2">
                    <el-input v-model="cutTime.id" size="small" disabled></el-input>
                  </el-col>
                  <el-col :span="5" :offset="1">
                    <el-input v-model="cutTime.start" type="time" step="2" size="small" @blur="calculateTimeEnd(index, chooseSeason)"></el-input>
                  </el-col>
                  <el-col :span="5" :offset="1"><el-input v-model="cutTime.duration" type="time" step="2" size="small" @blur="calculateTimeEnd(index, chooseSeason)"></el-input></el-col>
                  <el-col :span="5" :offset="1"><el-input v-model="cutTime.end" type="time" step="2" size="small" @blur="calculateTimeEnd(index, chooseSeason)" disabled></el-input></el-col>
                  <el-col :span="1" :offset="1"><i @click="addCuts(index, chooseSeason)" class="el-icon-circle-plus text-orange" style="font-size:25px"></i></el-col>
                  <el-col :span="1"><i @click="removeCut(index, chooseSeason)" class="el-icon-remove text-dark-gray-3" style="font-size:25px"></i></el-col>
                </el-col>
              </el-row>
            </el-tab-pane>
            <!-- Rangos -->
            <el-tab-pane name="rangers" label="RANGOS" :disabled="material.videoCutting[chooseSeason - 1].applyAllChapters" class="tabMargin">
              <p class="fonts-bold-general" style="margin-bottom: 1rem">Establecer Rango de Capítulos:</p>
              <!-- Definir rangos de capítulos -->
              <div class="bg-gray" style="padding: 0.5rem 1rem; width: 22rem">
                <el-row style="margin-bottom: 1rem">
                  <el-col :span="3" class="fonts-bold-general" style="margin-top: 6px">De:</el-col>
                  <el-col :span="4" class="fonts-bold-general">
                    <!-- @keyup.native="duplicateChapter(chooseSeason, initialChapter)" -->
                    <el-input v-model="initialChapter" size="small" 
                      @blur="duplicateChapter(chooseSeason, initialChapter)" v-on:keypress.native="isNumber"
                      @focus="isShowModal('rangersOrInvidual', 'rangers')"></el-input>
                  </el-col>
                  <el-col :span="5" :offset="1" class="fonts-bold-general" style="margin-top: 6px">Hasta:</el-col>
                  <el-col :span="4" class="fonts-bold-general">
                    <!-- @keyup.native="duplicateChapter(chooseSeason, initialChapter)" -->
                    <el-input v-model="endChapter" size="small" 
                      @blur="duplicateChapter(chooseSeason, endChapter)" v-on:keypress.native="isNumber" 
                      @focus="isShowModal('rangersOrInvidual', 'rangers')"></el-input>
                  </el-col>
                  <el-col :span="5" :offset="2">
                    <el-button v-if="showButtonEdit" @click="updateRange(chooseSeason)" type="primary" size="mini">EDITAR</el-button>
                    <el-button v-else @click="setRange(chooseSeason)" type="primary" size="mini">CREAR</el-button>
                  </el-col>
                </el-row>
                <el-row v-if="material.videoCutting" v-for="(item, index) in material.videoCutting[chooseSeason - 1].chapterRanges"
                  :key="index" class="bg-white" type="flex" align="middle" style="padding: 1px 1rem; margin-bottom: 0.5rem">
                  <el-col :span="18">
                    <p>De <span style="margin: 0 0.5rem">{{item.startChapter}}</span> hasta <span style="margin: 0 0.5rem;">{{item.finalChapter}}</span></p>
                  </el-col>
                  <el-col :span="6" class="text-end">
                    <img @click="editRanges(chooseSeason, index)" src="../../assets/images/edit.svg" width="22" style="margin: 3px 0 0" alt="edit"> 
                    <img @click="removElement(chooseSeason, index, 'chapterRanges')" src="../../assets/images/basura-2.svg" width="22" style="margin: 3px 0 0 5px" alt="garbage">
                  </el-col>
                </el-row>
              </div>
              <!-- CORTES -->
              <div v-if="material.videoCutting" v-for="(item, index) in material.videoCutting[chooseSeason - 1].chapterRanges"
                :key="index">
                <hr class="line-card" style="margin: 3rem 0 2rem">
                <h4 class="text-orange" style="margin-left: 2rem">CORTES DEL CAP. {{item.startChapter}} AL {{item.finalChapter}}:</h4>
                <!-- Duración artística -->
                <el-row style="margin: 2rem 0 2rem 2rem" type="flex" align="middle">
                  <el-col :span="12">
                    <el-row type="flex" align="middle">
                      <el-col :span="10">
                        <p class="fonts-bold-general">Duración Artística:</p>
                      </el-col>
                      <el-col :span="7">
                        <el-input v-model="item.artisticDuration" type="time" step="2" size="small" :disabled="true"></el-input>
                      </el-col>
                    </el-row>
                  </el-col>
                  <el-col :span="12">
                    <el-checkbox class="checkSize" v-model="item.applyAllRanks" @change="changeAllRanks(chooseSeason, index)"><strong>Aplicar A Todos Los Rangos</strong></el-checkbox>
                  </el-col>
                </el-row>
                <!-- Factores para crear Cortes -->
                <el-row style="margin: 0 0 3rem 2rem">
                  <el-col :span="12">
                    <p class="fonts-bold-general" style="margin-bottom: 1rem">Ingresa el Número de Cortes:</p>
                    <el-col :span="14" class="bg-gray" style="padding: 6px 1rem">
                      <el-col :span="14" class="fonts-bold-general" style="margin-top: 6px">N° de Cortes:</el-col>
                      <el-col :span="7"><el-input v-model="item.numberOfCuts" maxlength="3" size="small" v-on:keypress.native="isNumber"></el-input></el-col>
                    </el-col>
                  </el-col>
                  <el-col :span="12">
                    <p class="fonts-bold-general" style="margin-bottom: 1rem">Ingresa la Duración de los Cortes:</p>
                    <el-col :span="16" class="bg-gray" style="padding: 6px 1rem">
                      <el-col :span="16" class="fonts-bold-general" style="margin-top: 6px">Tiempo de Cortes:</el-col>
                      <el-col :span="6"><el-input v-model="item.timeOfCut" maxlength="2" size="small" @keyup.enter.native.prevent="makeCutSpecific(chooseSeason, index, 'chapterRanges')" v-on:keypress.native="isNumber"></el-input></el-col>                
                    </el-col>
                  </el-col>
                </el-row>
                <!-- Creando Cortes -->
                <el-row style="margin-left: 2rem">
                  <el-col :span="18" v-show="material.videoCutting[chooseSeason - 1].chapterRanges[index].cuts.length > 0" style="margin-bottom:1.2rem">
                    <el-col :span="2" class="fonts-bold-general">Corte:</el-col>
                    <el-col :span="5" :offset="1" class="fonts-bold-general">T.C. Inicio:</el-col>
                    <el-col :span="5" :offset="1" class="fonts-bold-general">Duración:</el-col>
                    <el-col :span="5" :offset="1" class="fonts-bold-general">T.C. Fin:</el-col>
                  </el-col>
                  <el-col :span="18" v-for="(cutTime, index2) in material.videoCutting[chooseSeason - 1].chapterRanges[index].cuts" style="margin-bottom: 0.6rem"
                    :id="index2" :key="index2">
                    <el-col :span="2"><el-input v-model="cutTime.id" size="small" disabled></el-input></el-col>
                    <el-col :span="5" :offset="1"><el-input v-model="cutTime.start" type="time" step="2" size="small" @blur="calculateTimeEndSpecific(chooseSeason, index, index2, 'chapterRanges')"></el-input></el-col>
                    <el-col :span="5" :offset="1"><el-input v-model="cutTime.duration" type="time" step="2" size="small" @blur="calculateTimeEndSpecific(chooseSeason, index, index2, 'chapterRanges')"></el-input></el-col>
                    <el-col :span="5" :offset="1"><el-input v-model="cutTime.end" type="time" step="2" size="small" @blur="calculateTimeEndSpecific(chooseSeason, index, index2, 'chapterRanges')" disabled></el-input></el-col>
                    <el-col :span="1" :offset="1"><i @click="addCutsSpecific(chooseSeason, index, index2, 'chapterRanges')" class="el-icon-circle-plus text-orange" style="font-size:25px"></i></el-col>
                    <el-col :span="1"><i @click="removeCutSpecific(chooseSeason, index, index2, 'chapterRanges')" class="el-icon-remove text-dark-gray-3" style="font-size:25px"></i></el-col>
                  </el-col>
                </el-row>
              </div>
            </el-tab-pane>
            <!-- Capítulos individuales -->
            <el-tab-pane name="capsIndividual" label="CAPÍTULOS INDIVIDUALES" :disabled="material.videoCutting[chooseSeason - 1].applyAllChapters" class="tabMargin">
              <p class="fonts-bold-general" style="margin-bottom: 1rem">Ingresa el Capítulo:</p>
              <!-- Definir capítulos individuales -->
              <div class="bg-gray" style="padding: 0.5rem 1rem; width: 15rem">
                <el-row style="margin-bottom: 1rem">
                  <el-col :span="8" class="fonts-bold-general" style="margin-top: 6px">Capítulo:</el-col>
                  <el-col :span="6" class="fonts-bold-general">
                    <!-- @keyup.native="duplicateChapter(chooseSeason, indiChapter)" -->
                    <el-input v-model="indiChapter" size="small" v-on:keypress.native="isNumber"
                      @blur="duplicateChapter(chooseSeason, indiChapter)" @focus="isShowModal('rangersOrInvidual', 'capsIndividual')"></el-input>
                  </el-col>
                  <el-col :span="5" :offset="2">
                    <el-button v-if="showButtonEdit2" @click="updateIndiChapters(chooseSeason)" type="primary" size="mini">EDITAR</el-button>
                    <el-button v-else @click="setIndividualChapters(chooseSeason)" type="primary" size="mini">CREAR</el-button>
                  </el-col>
                </el-row>
                <el-row v-if="material.videoCutting" v-for="(item, index) in material.videoCutting[chooseSeason - 1].individualChapters"
                  :key="index" class="bg-white" type="flex" align="middle" style="padding: 1px 1rem; margin-bottom: 0.5rem">
                  <el-col :span="14">
                    <p>{{item.chapter}}</p>
                  </el-col>
                  <el-col :span="10" class="text-end">
                    <img @click="editIndiChapter(chooseSeason, index)" src="../../assets/images/edit.svg" width="22" style="margin: 3px 0 0" alt="edit"> 
                    <img @click="removElement(chooseSeason, index, 'individualChapters')" src="../../assets/images/basura-2.svg" width="22" style="margin: 3px 0 0 5px" alt="garbage">
                  </el-col>
                </el-row>
              </div>
              <!-- CORTES -->
              <div v-if="material.videoCutting" v-for="(item, index) in material.videoCutting[chooseSeason - 1].individualChapters"
                :key="index">
                <hr class="line-card" style="margin: 3rem 0 2rem">
                <h4 class="text-orange" style="margin-left: 2rem">CORTES DEL CAPÍTULO {{item.chapter}}:</h4>
                <!-- Duración artística -->
                <el-row style="margin: 2rem 0 2rem 2rem" type="flex" align="middle">
                  <el-col :span="12">
                    <el-row type="flex" align="middle">
                      <el-col :span="10">
                        <p class="fonts-bold-general">Duración Artística:</p>
                      </el-col>
                      <el-col :span="7">
                        <el-input v-model="item.artisticDuration" type="time" step="2" size="small" :disabled="true"></el-input>
                      </el-col>
                    </el-row>
                  </el-col>
                  <el-col :span="12">
                    <el-checkbox class="checkSize" v-model="item.applyAllIndiChapters" @change="changeAllIndiChapters(chooseSeason, index)"><strong>Aplicar A Todos Los Cap. Individuales</strong></el-checkbox>
                  </el-col>
                </el-row>
                <!-- Factores para crear Cortes -->
                <el-row style="margin: 0 0 3rem 2rem">
                  <el-col :span="12">
                    <p class="fonts-bold-general" style="margin-bottom: 1rem">Ingresa el Número de Cortes:</p>
                    <el-col :span="14" class="bg-gray" style="padding: 6px 1rem">
                      <el-col :span="14" class="fonts-bold-general" style="margin-top: 6px">N° de Cortes:</el-col>
                      <el-col :span="7"><el-input v-model="item.numberOfCuts" maxlength="3" size="small" v-on:keypress.native="isNumber"></el-input></el-col>
                    </el-col>
                  </el-col>
                  <el-col :span="12">
                    <p class="fonts-bold-general" style="margin-bottom: 1rem">Ingresa la Duración de los Cortes:</p>
                    <el-col :span="16" class="bg-gray" style="padding: 6px 1rem">
                      <el-col :span="16" class="fonts-bold-general" style="margin-top: 6px">Tiempo de Cortes:</el-col>
                      <el-col :span="6"><el-input v-model="item.timeOfCut" maxlength="2" size="small" @keyup.enter.native.prevent="makeCutSpecific(chooseSeason, index, 'individualChapters')" v-on:keypress.native="isNumber"></el-input></el-col>                
                    </el-col>
                  </el-col>
                </el-row>
                <!-- Creando Cortes -->
                <el-row style="margin-left: 2rem">
                  <el-col :span="18" v-show="material.videoCutting[chooseSeason - 1].individualChapters[index].cuts.length > 0" style="margin-bottom:1.2rem">
                    <el-col :span="2" class="fonts-bold-general">Corte:</el-col>
                    <el-col :span="5" :offset="1" class="fonts-bold-general">T.C. Inicio:</el-col>
                    <el-col :span="5" :offset="1" class="fonts-bold-general">Duración:</el-col>
                    <el-col :span="5" :offset="1" class="fonts-bold-general">T.C. Fin:</el-col>
                  </el-col>
                  <el-col :span="18" v-for="(cutTime, index2) in material.videoCutting[chooseSeason - 1].individualChapters[index].cuts" style="margin-bottom: 0.6rem"
                    :id="index2" :key="index2">
                    <el-col :span="2"><el-input v-model="cutTime.id" size="small" disabled></el-input></el-col>
                    <el-col :span="5" :offset="1"><el-input v-model="cutTime.start" type="time" step="2" size="small" @blur="calculateTimeEndSpecific(chooseSeason, index, index2, 'individualChapters')"></el-input></el-col>
                    <el-col :span="5" :offset="1"><el-input v-model="cutTime.duration" type="time" step="2" size="small" @blur="calculateTimeEndSpecific(chooseSeason, index, index2, 'individualChapters')"></el-input></el-col>
                    <el-col :span="5" :offset="1"><el-input v-model="cutTime.end" type="time" step="2" size="small" @blur="calculateTimeEndSpecific(chooseSeason, index, index2, 'individualChapters')" disabled></el-input></el-col>
                    <el-col :span="1" :offset="1"><i @click="addCutsSpecific(chooseSeason, index, index2, 'individualChapters')" class="el-icon-circle-plus text-orange" style="font-size:25px"></i></el-col>
                    <el-col :span="1"><i @click="removeCutSpecific(chooseSeason, index, index2, 'individualChapters')" class="el-icon-remove text-dark-gray-3" style="font-size:25px"></i></el-col>
                  </el-col>
                </el-row>
              </div>
            </el-tab-pane>
          </el-tabs>
        </div>
        <!-- Material sin capítulos -->
        <div v-else>
          <div class="bg-light-red fonts-bold-general" style="padding: 0.5rem 1.5rem; margin: 1rem 1rem 0 0 ; width: 16rem">Este material NO tiene Capítulos</div>
          <!-- CORTES -->
          <div class="tabMargin">
            <h4 class="text-orange">CORTES DEL MATERIAL:</h4>

            <el-row style="margin: 0 0 0 0" v-show="isCodM">
              <template v-if="supportData && supportData.length > 1">
                <el-col :span="6">
                  <p class="fonts-bold-general" style="margin-top: 7px">Seleccionar Capítulo:</p>
                </el-col>
                <el-col :span="6">
                  <app-select v-model="selectChapter" :filterArray="getChapters"></app-select>
                </el-col>
              </template>
              <el-col :span="6">
                <p class="fonts-bold-general" style="margin-top: 7px">Seleccionar Rollo:</p>
              </el-col>
              <el-col :span="6">
                <app-select v-model="selectRoll" :filterArray="rolls"></app-select>
              </el-col>
            </el-row>

            <!-- Duración artística -->
            <el-row v-if="material.videoCutting" style="margin: 20px 0;">
              <el-col :span="4">
                <p class="fonts-bold-general" style="margin-top: 7px">Duración Artística:</p>
              </el-col>
              <el-col :span="4">
                <!-- v-model="material.videoCutting[chooseSeason - 1].allChapters.artisticDuration" -->
                <el-input v-model="material.videoCutting[chooseSeason - 1].allChapters.artisticDuration" type="time" step="2" size="small" :disabled="true"></el-input>
              </el-col>
            </el-row>
            <!-- Factores para crear Cortes -->
            <el-row style="margin: 50px 0;">
              <el-col :span="12">
                <p class="fonts-bold-general" style="margin-bottom: 1rem">Ingresa el Número de Cortes:</p>
                <el-col :span="14" class="bg-gray" style="padding: 6px 1rem">
                  <el-col :span="14" class="fonts-bold-general" style="margin-top: 6px">N° de Cortes:</el-col>
                  <el-col :span="7"><el-input v-model="numberOfCuts" maxlength="3" size="small" @keyup.enter.native="$refs.jump5.focus" v-on:keypress.native="isNumber"></el-input></el-col>
                </el-col>
              </el-col>
              <el-col :span="12">
                <p class="fonts-bold-general" style="margin-bottom: 1rem">Ingresa la Duración de los Cortes:</p>
                <el-col :span="16" class="bg-gray" style="padding: 6px 1rem">
                  <el-col :span="16" class="fonts-bold-general" style="margin-top: 6px">Tiempo de Cortes:</el-col>
                  <el-col :span="6"><el-input v-model="timeOfCut" maxlength="2" size="small" ref="jump5" @keyup.enter.native.prevent="makeCuts(chooseSeason, timeOfCut)" v-on:keypress.native="isNumber"></el-input></el-col>                
                </el-col>
              </el-col>
            </el-row>
            <!-- Creando Cortes -->
            <el-row v-if="material.videoCutting">
              <el-col :span="18" v-show="material.videoCutting && material.videoCutting[chooseSeason - 1].allChapters.cuts.length > 0" style="margin-bottom:1.2rem">
                <el-col :span="2" class="fonts-bold-general">Corte:</el-col>
                <el-col :span="5" :offset="1" class="fonts-bold-general">T.C. Inicio:</el-col>
                <el-col :span="5" :offset="1" class="fonts-bold-general">Duración:</el-col>
                <el-col :span="5" :offset="1" class="fonts-bold-general">T.C. Fin:</el-col>
              </el-col>
              <el-col :span="18" v-for="(cutTime, index) in material.videoCutting[chooseSeason - 1].allChapters.cuts" style="margin-bottom: 0.6rem"
                :id="index" :key="index">
                <el-col :span="2"><el-input v-model="cutTime.id" size="small" disabled></el-input></el-col>
                <el-col :span="5" :offset="1"><el-input v-model="cutTime.start" type="time" step="2" size="small" @blur="calculateTimeEnd(index, chooseSeason)"></el-input></el-col>
                <el-col :span="5" :offset="1"><el-input v-model="cutTime.duration" type="time" step="2" size="small" @blur="calculateTimeEnd(index, chooseSeason)"></el-input></el-col>
                <el-col :span="5" :offset="1"><el-input v-model="cutTime.end" type="time" step="2" size="small" @blur="calculateTimeEnd(index, chooseSeason)" disabled></el-input></el-col>
                <el-col :span="1" :offset="1"><i @click="addCuts(index, chooseSeason)" class="el-icon-circle-plus text-orange" style="font-size:25px"></i></el-col>
                <el-col :span="1"><i @click="removeCut(index, chooseSeason)" class="el-icon-remove text-dark-gray-3" style="font-size:25px"></i></el-col>
              </el-col>
            </el-row>
          </div>
        </div>
        <!-- BOTÓN CANCELAR Y CREAR -->
        <div class="text-end" style="margin-top: 6rem">
          <el-button @click="modalCancelButton = true" class="text-orange border-orange" plain>CANCELAR</el-button>
          <el-button @click="createCuts(material)" :disabled="(disableCreateButton && !unlockEdit) || dialogNotRoll" style="margin-left: 3rem; padding: 0.75rem 2.5rem" type="primary">
            <span v-if="material.materialWithCuts == false">CREAR</span>
            <span v-else>ACTUALIZAR</span>
          </el-button>
        </div>
        <!-- Modal botón cancelar -->
        <AppModalDanger :show-dialog.sync="modalCancelButton" v-if="modalCancelButton" parrafo="¿Estás seguro de que quieres cancelar los cortes ingresados?"  v-on:btnEvent="viewListMaterials"  @btnEvent="modalCancelButton = false" v-on:eventBtn="modalCancelButton = false">
        </AppModalDanger>
        <!-- Modal botón ingresar-->
        <AppModalSuccess :show-dialog.sync="modalCreateCut" v-if="modalCreateCut" :styleModal="true"
          :parrafo="msgModalCuts" btn1="ACEPTAR" v-on:btnEvent="modalCreateCut = false" @btnEvent="viewListMaterials">
        </AppModalSuccess>
        <AppModal 
          ref="showModal"
          v-if="messageExist"
          :show-dialog.sync="messageExist"
          :parrafo=" textShow "
          :styleBox="true"
          nameClass="dialog-red"
          :rutImg="require('../../assets/images/alerta.svg')" sizeImg="60px"
          ></AppModal>

        <AppModal 
          ref="qwerty"
          v-if="dialogNotRoll"
          :show-dialog.sync="dialogNotRoll"
          :parrafo="message"
          :styleBox="true"
          nameClass="dialog-red"
          :rutImg="require('../../assets/images/alerta.svg')" sizeImg="60px"
          ></AppModal>


        <!-- Este capitulo no existe  Modal-->
        <AppModal 
          ref="showModal"
          v-if="capNotExist"
          :show-dialog.sync="capNotExist"
          :parrafo=" textShowCapExist"
          :styleBox="true"
          nameClass="dialog-red"
          :rutImg="require('../../assets/images/icon-delete.svg')" sizeImg="60px"
          > </AppModal>
          <!-- Elección de cortes por todos los capitulos o de cortes por rangos y capitulos -->
        <AppModal
          v-if="capTypeCut"
          :show-dialog.sync="capTypeCut"
          :parrafo=" textShowTypeCut"
          :styleModal="true"
          :show="false"
          textBold="Un momento"
          btn1="SÍ, ELIMINAR"
          classBtn1="firstBtn"
          classBtn2="secondBtn"
          btn2="CANCELAR"
          nameClass="dialog-red"
          @btnEvent="cleanInfo"
          @eventBtn="cancelModal"
          :rutImg="require('@/assets/images/alerta.svg')" sizeImg="60px"
          > </AppModal>
          
        <el-dialog :visible.sync="alertPrevToSave" width="33%" :show-close="false" custom-class="dialog-red"
          :close-on-press-escape="false" :close-on-click-modal="false"> 
          <el-row style="display: flex; align-items: center;">
            <el-col :span="5" class="text-center">
              <img :src="require(`@/assets/images/alerta.svg`)" alt="emoticon" width="80px">
            </el-col>
            <el-col :span="18" :offset="1">
              <p> Por favor, <span class="text-bold text-green"> ESPERE </span> mientras se guarda la información...</p>
            </el-col>
          </el-row>
        </el-dialog>

      </el-main>
    </div>
  </div>
</template>

<script>
// import AppNav from '@/components/AppNav.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import AppModalReturn from '@/components/AppModalReturn.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import AppModal from '@/components/AppModal.vue'
import AppSelect from '@/components/AppSelect.vue'
import { addTimes, restTimes, padNmb } from '../../utils/calculateTime.js'
import {HTTP} from '@/main.js'

  /**
  * @vue-data {String} initialChapter - cuando son varios capitulos, indica el capitulo inicial
  * @vue-data {String} endChapter - cuando son varios capitulos, indica el capitulo final
  * @vue-data {String} watchDuration - activa el modal dependiendo de la duracion artistica con respecto a los cortes
  * @vue-computed {Object} material - Objeto que trae el material
  */

export default {
  name : "CutPage",
  components: {
    AppModalReturn,
    ReturnButton,
    AppModalDanger,
    AppModalSuccess,
    AppModal,
    AppSelect,
  },
  data () {
    return {
      isCodM: true,
      message: '',
      dialogNotRoll: false,
      selectChapter: '',
      rolls: [],
      selectRoll: '',
      returnButtonModal: false,
      modalCancelButton: false,
      modalCreateCut: false,
      disableCreateButton: true,
      watchDuration: '', // Para vigilar Duración Artística y activar alert
      numberOfCuts: '',
      timeOfCut: '',
      tci: '',
      duration: '',
      tcf: '',
      chooseSeason: '1',
      initialChapter: '', //Rangos
      endChapter: '', //Rangos
      indiChapter: '', //Capítulo individual
      showButtonEdit: false, //Rangos
      showButtonEdit2: false, //Capítulo individual
      indexRange: '',
      indexIndiChapters: '',
      userName: '',
      userEmail: localStorage.getItem('userEmail'),
      haveCuts: false,
      unlockEdit: false,
      messageExist: false,
      capNotExist: false,
      textShow: '',
      textShowCapExist: '',
      activeName: 'allChapters',
      typeCuts: '',
      capTypeCut: false,
      textShowTypeCut: '',
      capTypeCutPrev: false,
      controllerModal: false,
      positionEdit: '',
      msgModalCuts: '',
      supportData: [],
      alertPrevToSave: false,
      cutsMaterialInitialValue: '',
    }
  },
  computed: {
    /**Traer la cantidad de capitulos*/
    getChapters() {
      let newSupportData = []
      if (this.supportData && this.supportData.length > 1) {
        this.supportData.map(row => {
          const {stringMaterialType} = this.$store.state.material
          const {storages, supportMaterial, chapter, typeStorage, storage} = row
          let conditional = stringMaterialType ? stringMaterialType.toLowerCase() : ''
          if(conditional === ('afiliación-televisa' || "afiliación/televisa")) {
            if(typeStorage && typeStorage !== null && typeStorage !== '' && typeStorage.length > 0 && typeStorage[0].typeStorage && storage && storage !== null && storage !== '') {
                  newSupportData.push({
                'value': String(chapter),
                'label': String(chapter),
              })
            }
          } else {
            const {codeDisk, typeStorage} = supportMaterial && supportMaterial.length > 0 ? supportMaterial[0] : []
            if(storages && storages !== '' && storages !== null && typeStorage && typeStorage !== '' && typeStorage !== null){
              newSupportData.push({
                'value': String(chapter),
                'label': String(chapter),
              })
            }
          }
          
        });
      }
      return newSupportData
    },
    material() {
      let data = this.$store.state.material
      if(data.videoCutting && data.videoCutting.length > 0) {
        const {individualChapters} = data.videoCutting[0]
        let transform = individualChapters.map((e)=> ({
            applyAllIndiChapters: false,
            artisticDuration: e.artisticDuration,
            chapter: e.chapter,
            cuts: e.cuts,
            numberOfCuts: e.numberOfCuts,
            timeOfCut: e.timeOfCut
        }))
        data.videoCutting[0].individualChapters = transform
      }

      if(this.cutsMaterialInitialValue == '' || this.cutsMaterialInitialValue == null){
        if(this.$store.state.material.videoCutting == undefined){
          this.$localStorage.set('cutsMaterialInitialValue', '')
        } else {  
          this.$localStorage.set('cutsMaterialInitialValue', JSON.stringify(this.$store.state.material.videoCutting))
        }
        this.cutsMaterialInitialValue = JSON.parse(this.$localStorage.get('cutsMaterialInitialValue'))
      }
      return data ? data : this.$store.state.material
    },
    durationArtistic() {
      if(this.material.videoCutting && this.material.videoCutting.length > 0 && this.material.videoCutting[this.chooseSeason - 1].allChapters.cuts && this.material.videoCutting[this.chooseSeason - 1].allChapters.cuts.length > 0) {
        return this.material.videoCutting[this.chooseSeason - 1].allChapters.artisticDuration
      } else {
        return this.material.videoCutting && this.material.videoCutting.length > 0 ? this.material.videoCutting[this.chooseSeason - 1].artisticDuration : '00:00:00'
      }
    },
  },
  watch: {    
    dialogNotRoll(val) {
      if (!val) this.message = ''
    },
    selectChapter(val) {
      if (val != '') {
        this.getRolls(val);
        if (this.rolls.length == 0) {
          this.dialogNotRoll = true;
          this.message = 'El capítulo no tiene ROLLO ni CORTES.';
        };
      }
    },
    selectRoll(val) {
      if (val != '') {
        let url = `/materials/codMaterial/${this.material.codMaterial}/numberRollo/${this.selectRoll}/chapter/1`;
        HTTP.get(url)
          .then(res => {
            let cuts = res.data.individualsCuts[0].cuts;
            console.log('res cut', cuts);
            console.log(this.$store.state.material.videoCutting);
            this.$store.state.material.videoCutting[0].allChapters.cuts = cuts;
          })
      }
    },
    durationArtistic (val) {
      if(val < '00:00:00') {
        this.validateCuts()
      }
    },
    showButtonEdit(val) {
      val = false
    },
    async material(val) {
      let contractData
      let {stringMaterialType, contractCode, codMaterial, numChapters, listTitle, supportObj} = val
      if(contractCode && codMaterial) {
        switch (stringMaterialType) {
          case 'Enlatado':
            contractData = await this.getInfoAboutContract(contractCode, codMaterial)
            break;
          case ('Afiliación-Televisa'|| 'Afiliación/Televisa'):
            contractData = this.getCutsData(this.material)
            break;
        }       
      } else {
        switch (stringMaterialType) {
          case 'Producción Nacional':
            /*Produccion nacional*/
            /*Con capítulos*/
            let array
            if(numChapters && numChapters.length > 0 && numChapters[0].infoByChapter.length > 0) {
              const {infoByChapter} = numChapters[0]
              array  = [ ...new Set (infoByChapter.map((e) => {
                  return {
                    chapter: e.chapter,
                    storages: 'Producción Nacional',
                    supportMaterial: 'FICT'
                  }
              }))]
              contractData = array && array[0] ? array : undefined
            } else {
            /*Sin capítulos*/
              contractData = [{
                chapter: 1,
                storages: 'Producción Nacional',
                supportMaterial: 'FICT'
              }]
            }
            break;
          case 'Afiliación-Televisa':
          case 'Afiliación/Televisa':
            contractData = this.getCutsData(this.material)
            break;
        }  
        
      }
      this.supportData = contractData
    }
  },
  async created () {
    await this.fetchMaterial()
    this.gettingUsername()
    if (this.supportData == undefined) {
      this.dialogNotRoll = true;
      this.message = 'El capítulo no tiene ROLLO ni CORTES.'
    }
    if (this.material.codMaterial.charAt(0) == 'M'){
      this.isCodM = false;
    }else{
      this.getRolls();
    }
  },
  beforeDestroy() {
    this.$store.dispatch("getData", "materials/allMaterials/allMaterials")
  },
  methods: {
    /**Traer la lista de los rollos*/
    getRolls(chapterNumber=1) {
      let number;
      if ( this.supportData == undefined || this.supportData.length == 1 ) number = 1;
      else number = chapterNumber;
      let url = `materials/getCutsByGeminisCode/${this.material.codMaterial}/chapter/${number}`;
      HTTP.get(url)
        .then(res=> {
          this.rolls = res.data.rollos.map( row => {
            return {
              'value': String(row),
              'label': String(row)
            }
          })
          console.log('rolls', this.rolls);
          if (this.rolls.length == 1) this.selectRoll = this.rolls[0].value;
        });
    },
 
    // addCuts(index, cuts, indiceChapter) {
    //   console.log("primero")
    //   /*DEBO HACERLO DE ESTA MANERA DEBIDO A QUE EL CORTE NUEVO SE ESTABA AGREGANDO A MI RANGO INICIAL*/
    //   this.arrCuts = [] 

    //   if(cuts.length > 0){
    //     cuts.map((cut)=>{
    //       this.arrCuts.push(cut)
    //     })
    //   }

    //   this.arrCuts.map((el, i, arr) => {
    //     if (i == index) {
    //       let obj = {'id': i+2, 'start': '00:00:00', 'duration': '00:00:00', 'end': '00:00:00'}
    //       this.arrCuts.splice(i + 1, 0, obj);
    //     }
    //   });

    //   // MODIFICO EL ID DE LOS CORTES
    //   for(let i=0; i<this.arrCuts.length; i++){
    //     this.arrCuts[i].id = i+1
    //   }

    //   //REEMPLAZADO VALORES A MOSTRAR
    //   this.capsByDay[indiceChapter].cuts = this.arrCuts
    // },
    gettingUsername(){
      let user = this.userEmail.split('@')[0]
      this.userName = user.toUpperCase()
    },
    /**Traer los datos del material selccionado para cortes*/
    async fetchMaterial () {
      let materialId = JSON.parse(this.$localStorage.get('materialId'))
      let payload = {
        id: materialId,
        type: 'materials'
      }
      let res = await HTTP.get(`${payload.type}/${payload.id}`);
      /* Verificar si tiene videoCutting */
      if(res.data.material.videoCutting.length==0){
        let videoCutting = [];
        const numChapters = res.data.material.numChapters;
        if(numChapters.length==0){
          videoCutting.push({
            season:"",
            chapters:"",
            applyAllChapters:false,
            artisticDuration:`${res.data.material.hoursMaterial}:${res.data.material.minutesMaterial}:00`,
            chapterRanges:[],
            individualChapters:[],
            allChapters:{artisticDuration: `${res.data.material.hoursMaterial}:${res.data.material.minutesMaterial}:00`, cuts:[]}
          })
        }
        numChapters.forEach(cap=>{
          let obj = {};
          obj.season =  cap.season;
          obj.chapters = cap.chapters;
          obj.applyAllChapters = false;
          obj.artisticDuration = `${res.data.material.hoursMaterial}:${res.data.material.minutesMaterial}:00`;
          obj.chapterRanges = [];
          obj.individualChapters = [];
          obj.allChapters = {artisticDuration: obj.artisticDuration, cuts:[]}
          videoCutting.push(obj)
        })
        res.data.material.videoCutting = videoCutting;
      }
      this.$store.state.material = res.data.material;
    },
    groupNumberConsecutive(data, materialWithCuts) {
        let result = data.reduce((r, n) => {
        const lastSubArray = r[r.length - 1];
        if (!lastSubArray || lastSubArray[lastSubArray.length - 1] !== n - 1) {
          r.push([]);
        }
        r[r.length - 1].push(n);
        return r;
      }, []);
      let all = ["Los cortes"];
      let countCaps = data.length;
      let textConditional = countCaps > 1 ? "de los capítulos" : "del capítulo";
      all.push(textConditional);
      let counterGroup = result.length;
      result.map((e, i) => {
        let conectorText = counterGroup > 1 && counterGroup === i + 1 ? "y " : "";
        if (e.length > 2) {
          all.push(`${conectorText}del ${e[0]} al ${e[e.length - 1]}`);
        } else if (e.length === 2) {
          let showComa = counterGroup > 1 && i !== 0 ? ", " : "";
          let conector = counterGroup === 1 ? " y " : ", ";
          all.push(`${showComa}${conectorText}${e.join(conector)}`);
        } else if (e.length === 1) {
          all.push(`${conectorText}${e[0]}`);
        }
      });
      let text = null
      if(materialWithCuts == true) {
        text = countCaps > 1 ?  'actualizaron' : 'actualizó'
      } else {
        text = countCaps > 1 ?  'crearón' : 'creó'
      }
      all.push(`se ${text} correctamente.`)
      return all.join(" ")
    },
    /**define el mensaje si en caso se crea o se actualizan los cortes del material
    * @param {Object} data - Es el material, objeto con los datos del material
    */
    definiteMessage(data,message) {
      const {materialWithCuts, stringMaterialType, numChapters} = data
      let isMatProdNac = stringMaterialType === "" || stringMaterialType === undefined || stringMaterialType == null || stringMaterialType.toLowerCase() === "producción nacional" ? true : false
      let haveCuts = numChapters && numChapters.length > 0 && Number(numChapters[0].chapters) > 0 ?  true : false
      let coincideCuts = numChapters && numChapters.length > 0 && Number(numChapters[0].chapters) > 0 ?  this.supportData.length == Number(numChapters[0].chapters) : false
      if(isMatProdNac == false && haveCuts == true && coincideCuts == false) {
        let capsForInsert = this.supportData.map((e) => e.chapter)
        let groupChapter = this.groupNumberConsecutive(capsForInsert, materialWithCuts )
        this.msgModalCuts = groupChapter
      } else {
        this.msgModalCuts = materialWithCuts == true ? message : 'Los cortes del material se crearon correctamente.'
      }
      console.log({s: this.msgModalCuts})
    },
    /**Cres los cortes en el material y envia  los datos, actualiza el material
    * @param {Object} material - Trae el objeto al material correspondiente
    */
    async createCuts(material) {
      this.alertPrevToSave = true
      this.unlockEdit = false
      let part = material.videoCutting[this.chooseSeason - 1];
      if((part.allChapters.cuts.length !== 0) || (part.chapterRanges.length !== 0) || (part.individualChapters.length !== 0) ){
        this.haveCuts = true
      } else {
        this.haveCuts = false
      }
      // this.definiteMessage(material)
     
      const {beforeDurationMaterial, hoursMaterial, minutesMaterial} = this.material

      this.material.videoCutting = this.material.videoCutting.map((e) => {
        const {allChapters, ...rest} = e
        if(allChapters.cuts && allChapters.cuts.length >= 1) {
          const {artisticDuration, cuts} = allChapters
          return {
            allChapters: {
              artisticDuration,
              cuts: cuts.map((a) => {
                const {duration, end, id, start} = a
                return {
                  duration: this.calculateTimeCorrectForm(a.duration),
                  end: this.calculateTimeCorrectForm(a.end),
                  start: this.calculateTimeCorrectForm(a.start),
                  id
                }
              })
            },
            ...rest
          }
        } else {
          return {
            allChapters,
            ...rest
          }
        }
      })
      console.log(this.supportData, 'this.supportData')
      let payload = {
        mat:[
          { propName: "videoCutting", value: this.material.videoCutting},
          { propName: "materialWithCuts", value: this.haveCuts},
          { propName: "userName", value: this.userName},
          { propName: "userEmail", value: this.userEmail},
          { propName: "codMaterial", value: material.codMaterial},
          { propName: "conditionalCuts", value: true},
          { propName: "numChapters", value: this.material.numChapters},
          { propName: "geminisCode", value: this.material.geminisCode},
          { propName: "supportData", value: this.supportData},
          { propName: "beforeDurationMaterial", value: beforeDurationMaterial },
          { propName: "durationMaterial", value: `${hoursMaterial}:${minutesMaterial}:00` },
          { propName: "durationMaterialCreated", value: this.material.durationMaterialCreated },
          { propName: "rolFechaEstado", value: new Date().toLocaleString("en-GB",{day:'2-digit',month:'2-digit',year:'numeric'})}
          ],
        id: material._id,
        data: material,
        key: 'materials'
      }

      const {data} = await HTTP.patch(`${payload.key}/${payload.id}`, payload.mat)
      console.log(data, "RESPUESTA PATCH")
      this.definiteMessage(material, data.messageMongo)
      if(data) {
        this.alertPrevToSave = false;
        this.modalCreateCut = true;
      }
    },
    calculateTimeCorrectForm(val) {
      if(val) {
         let value
        value = val.length < 6 ? `${val}:00` : val
        return value
      }
    },
    viewListMaterials () {
      if (this.material.canned === true) {
        this.$router.push({name: 'material2'})
      } else {
        this.$router.push({name: 'material'})
      }
    },
    /**Validar si los cortes corresponden a la duracion del material o no*/
    validateCuts(){
      this.textShow = '<strong>Los cortes exceden la duración del material.</strong>'
      this.messageExist = true
    },
    /**Genera la cantidad de cortes con sus respectivos tiempos dependiendo de la duracion del material
    * @param {Number} season - temporada del cepitulo del material seleccionado
    * @param {Number} timeCut - timeOfCut, tiempo de corte
    */
    makeCuts (season, timeCut) {
      this.validNumber(timeCut)
      let artisticDuration = this.material.videoCutting[season - 1].artisticDuration // Durac. artística general
      if(this.capTypeCut == false) {
        if (this.numberOfCuts !== '' && this.timeOfCut !== '') {
          this.disableCreateButton = false // Habilitar botón crear
          this.material.videoCutting[season - 1].allChapters.cuts = []        
          var numberCuts = Number(this.numberOfCuts)
          var timeCut = this.timeOfCut
          var durationTotal = ''

          for (var i = 0; i < numberCuts; i++) {
            // Tiempo inicio de corte
            if (i == 0) {
              // var tci = '00:10:00'
              let arrTimeSec = artisticDuration.split(':')
              let sumTimeSec = (Number(arrTimeSec[0]*60) *60) + Number(arrTimeSec[1]*60)
              let second = '00'
              let hour = '00'
              let minute = '00'
              let cutTime = ''
              
              if(sumTimeSec<900){
                // SI LA DURACION ES MENOR A 15MIN
                minute = Math.floor((sumTimeSec / 2)/60)
                if(minute<10){
                  minute = '0' + minute 
                }
                cutTime = hour + ':' + minute + ':' + second
              } else {
                cutTime = '00:10:00'
              }

              var tci = cutTime
            } else {
              let timeInit = Number(i*10) + 20
              let timeInitSec = (Number(timeInit) * 60)
              var horInit = Math.floor(timeInitSec / 3600)
              if(horInit < 10){
                horInit = '0'+ String(horInit)
              }
              var minInit = Math.floor((timeInitSec - (horInit * 3600)) / 60)
              if(minInit < 10){
                minInit = '0'+ String(minInit)
              }
              var secInit = timeInitSec - (horInit * 3600) - (minInit * 60)
              if(secInit < 10){
                secInit = '0'+ String(secInit)
              }
              var tci = horInit + ':' + minInit + ':' + secInit
              let gettingCuts = this.material.videoCutting[season - 1].allChapters.cuts
              const previousCut = gettingCuts[gettingCuts.length -1]
              // VALIDAR QUE EL TIEMPO DE INICIO DEL CORTE ACTUAL NO SEA MENOR AL TIEMPO DE CORTE FINAL
              if(previousCut.end >= tci){
                this.validateCutInit(i)
                return false
              }
            }

            //Validar si los cortes superan la duracion del material
            var sep1 = artisticDuration.indexOf(':')
            var sep2 = artisticDuration.lastIndexOf(':')
            var horArtistic = artisticDuration.substr(0, sep1)
            var minArtistic = artisticDuration.substr(sep1 + 1, sep2 - sep1 - 1)
            var secArtistic = artisticDuration.substr(sep2 + 1)

            if(horInit>=horArtistic){
              if(horInit>horArtistic){
                this.validateCuts()
                return false
              } else if(horInit==horArtistic){
                if(minInit > minArtistic){
                  this.validateCuts()
                  return false
                }
              }
            }

            // Duración de corte
            timeCut = timeCut.length === 1 ? '0' + timeCut : timeCut
            var duration = '00:' + timeCut + ':00'
            durationTotal = addTimes(durationTotal, duration)


            // Tiempo fin de corte
            var tcf = addTimes(tci, duration)

            // REEMPLAZA LOS CORTES CREADOS
            // VALIDA SI EL TIEMPO DE CORTE FINAL NO EXCEDE LA DURACION DEL CAPITULO
            let totalDuration = artisticDuration

            if(tcf > totalDuration){
              this.validateCuts()
              return false
            } else {
              this.material.videoCutting[season - 1].allChapters.cuts.push({'id': i+1, 'start': tci, 'duration': duration, 'end': tcf})
            }

            // Restar tiempo a Duración artística
            this.material.videoCutting[season - 1].allChapters.artisticDuration = restTimes(artisticDuration, durationTotal)
            // Limpiar inputs
            this.numberOfCuts = ''
            this.timeOfCut = ''
          }
          
        } else{
          this.disableCreateButton = true // Deshabilitar botón crear
        }
      }
      
    },
    validateCutInit(i){
      this.textShow = `<strong>El tiempo de fin del corte ${i} es mayor al tiempo de inicio del corte ${i+1}.</strong>`
      this.messageExist = true
    },
    /**Calcular el tiempo final al editarlos en cada corte
    * @param {Number} index - posicion del corte que se quiere cambiar el tiempo de corte
    * @param {Number} season - temporada del capitulo que se quiere editar el corte
    */
    calculateTimeEnd (index, season) {
      let artisticDuration = this.material.videoCutting[season - 1].artisticDuration // Durac. artística general
      let arrCuts = this.material.videoCutting[season - 1].allChapters.cuts // Array donde se almacenan los cortes (objetos)

      if(arrCuts[index] !== undefined){
        var start = arrCuts[index].start
        var duration = arrCuts[index].duration
        var end = arrCuts[index].end
        var newDurationTotal = ''

        if (start.indexOf(':') === 2 && start.lastIndexOf(':') === 2) {
          start = arrCuts[index].start + ':00'
        } 
        
        if (duration.indexOf(':') === 2 && duration.lastIndexOf(':') === 2) {
          duration = arrCuts[index].duration + ':00'
        }

        // SOLO ENTRA A VALIDAR SI EL CORTE SELECCIONADO NO ES EL 1ER CORTE
        if(index>0){
          const previousCut = arrCuts[index-1]
          const cutSelect = arrCuts[index]
          
          if (cutSelect.start.indexOf(':') === 2 && cutSelect.start.lastIndexOf(':') === 2) {
            cutSelect.start = cutSelect.start + ':00'
          }
          
          // VALIDAR QUE EL TIEMPO DE INICIO DEL CORTE ACTUAL NO SEA MENOR AL TIEMPO DE CORTE FINAL
          if(previousCut.end >= cutSelect.start){
            arrCuts.splice(index, 1)
            this.validateCutInit(index)
            return false
          }
        }

        let totalDuration = artisticDuration

        const timeInit = start.split(':')
        const horInit = timeInit[0]
        const minInit = timeInit[1]
        let sep1 = totalDuration.indexOf(':')
        let sep2 = totalDuration.lastIndexOf(':')
        let horArtistic = totalDuration.substr(0, sep1)
        let minArtistic = totalDuration.substr(sep1 + 1, sep2 - sep1 - 1)
        let secArtistic = totalDuration.substr(sep2 + 1)
        
        if(horInit>=horArtistic){
          if(horInit>horArtistic){
            // MUESTRA MODAL CORTES EXCEDEN DURACION 
            this.validateCuts()
            // COMO NO SE VA A GUARDAR EN LA DATA EL CORTE EXCEDENTE, DEBERIA BORRARLO AUTOMATICAMENTE
            arrCuts.splice(index, 1)
            return false
          } else if(horInit==horArtistic){
            if(minInit >= minArtistic){
              // MUESTRA MODAL CORTES EXCEDEN DURACION
              this.validateCuts()
              // COMO NO SE VA A GUARDAR EN LA DATA EL CORTE EXCEDENTE, DEBERIA BORRARLO AUTOMATICAMENTE
              arrCuts.splice(index, 1)
              return false
            }
          }
        }
        
        // CALCULA LA DURACION FINAL DEL CORTE
        end = addTimes(start, duration)
        // VALIDA SI EL TIEMPO DE CORTE FINAL NO EXCEDE LA DURACION DEL CAPITULO
        if(end > totalDuration){
          this.validateCuts()
          arrCuts.splice(index, 1)
        } else {
          // ACTUALIZA EL CORTE YA CON SU DURACION FINAL
          arrCuts.splice(index, 1, {'duration': duration, 'end': end, 'start': start, 'id': index+1})
        }
        
        for (var i = 0; i < arrCuts.length; i++) {
          newDurationTotal = addTimes(newDurationTotal, arrCuts[i].duration)
        }

        // Restar tiempo a Duración artística
        this.material.videoCutting[season - 1].allChapters.artisticDuration = restTimes(artisticDuration, newDurationTotal)
        // Vigilar Duración Artística y activar alert
        if(JSON.stringify(this.material.videoCutting) !== JSON.stringify(this.cutsMaterialInitialValue)){
          this.unlockEdit = true
        }
      }
    },
    /**Borrar la fila del corte
    * @param {Number} index - posicion del corte que se quiere eliminar
    * @param {Number} season - temporada del capitulo que se quiere eliminar el corte
    */
    removeCut (index, season) {
      let artisticDuration = this.material.videoCutting[season - 1].artisticDuration // Durac. artística general
      let arrCuts = this.material.videoCutting[season - 1].allChapters.cuts // Array donde se almacenan los cortes (objetos)

      arrCuts.splice(index, 1)
      var newDurationTotal = ''

      for (var i = 0; i < arrCuts.length; i++) {
        newDurationTotal = addTimes(newDurationTotal, arrCuts[i].duration)
        arrCuts[i].id = i + 1
      }

      // Restar tiempo a Duración artística
      this.material.videoCutting[season - 1].allChapters.artisticDuration = restTimes(artisticDuration, newDurationTotal)
      // Vigilar Duración Artística y activar alert
      if(JSON.stringify(this.material.videoCutting) !== JSON.stringify(this.cutsMaterialInitialValue)){
        this.unlockEdit = true
      }
    },
    /**Agregar cortes
      * @param {Number} index - Posicion del corte en donde se quiere añadir un corte
      * @param {Number} season - Tempoarada del capitulo al que se quiere añadir ese corte
    */
    addCuts(index, season) {
      console.log("segundo")
      let arrCuts = this.material.videoCutting[season - 1].allChapters.cuts // Array donde se almacenan los cortes (objetos)

      arrCuts.map((el, i, arr) => {
        if (i == index) {
          arr.splice(i + 1, 0, {'id': i+2, 'start': '00:00:00', 'duration': '00:00:00', 'end': '00:00:00'});
        } 
      });

      for (var i = 0; i < arrCuts.length; i++) {
        arrCuts[i].id = i + 1
      }
    },
    /**Genera el rango de los capitulos en caso se quieran generar cortes en varios capitulos
    * @param {Number} season - Tempoarada del capitulo
    */
    setRange (season) {
      let chapterRanges = this.material.videoCutting[season - 1].chapterRanges
      let artisticDuration = this.material.videoCutting[season - 1].artisticDuration
      let newRank = {
        startChapter: this.initialChapter,
        finalChapter: this.endChapter,
        applyAllRanks: false,
        artisticDuration: artisticDuration,
        cuts: [],
        timeOfCut: '',
        numberOfCuts: ''
      }
      if (this.initialChapter && this.endChapter && this.capTypeCut == false) {
        // Generar estructura para los rangos
        chapterRanges.push(newRank)
        this.initialChapter = ''
        this.endChapter = ''
      }
    },
    /**Generar el corte en un capitulo en especifico
    * @param {Number} season - Temporada del capitulo
    */
    setIndividualChapters (season) {
      let individualChapters = this.material.videoCutting[season - 1].individualChapters
      let artisticDuration = this.material.videoCutting[season - 1].artisticDuration
      
      let newIndiChapter = {
        chapter: this.indiChapter,
        applyAllIndiChapters: false,
        artisticDuration: artisticDuration,
        cuts: [],
        timeOfCut: '',
        numberOfCuts: ''
      }

      if (this.indiChapter && this.capTypeCut == false) {
        // Generar estructura para los capítulos individuales
        individualChapters.push(newIndiChapter)
        this.indiChapter = ''
      }
    },
    /**Indica con un modal en caso el capitulo no exista*/
    chapterNotExist (season, number) {
      let totalChapters = this.material.videoCutting[season - 1].chapters

      // Verifica si el capitulo ingresado NO existe
      if (Number(number) > Number(totalChapters) || number == '0') {
        this.textShowCapExist = '<strong>El capítulo ingresado no existe.</strong>'
        this.capNotExist = true
        this.indiChapter = this.initialChapter =  this.endChapter = ''
      }
    },
    duplicateChapter (season, number) {
      this.chapterNotExist(season, number)
      const {chapterRanges, individualChapters} = this.material.videoCutting[season - 1]
      const chapterValue = Number(number)

      const cleanInputs = () => {
        this.messageExist = true
        this.indiChapter = ''
        this.validInput(number)
        this.showButtonEdit = false
      }
      
      // Verifica si el capítulo ingresado existe dentro de otro rango
      chapterRanges.map((el, i, arr) => {
        if (chapterValue >= Number(el.startChapter) && chapterValue <= Number(el.finalChapter)) {
          this.textShow = `<strong>El capítulo ${number} está incluído en el rango del ${el.startChapter} al ${el.finalChapter}.</strong>`
          this.showButtonEdit2 = false
          if(this.controllerModal == true ) {
            this.messageExist =  this.positionEdit == i ? false : cleanInputs()
          } else {
            cleanInputs()
          }
        }
      })

      
      let array = []
      individualChapters.map((el, i, arr) => {
        if (chapterValue >= Number(el.chapter)) {
          array.push(el.chapter)
        }
      })

      let arrayTryEnter = []
      for(let a = Number(this.initialChapter); a <= this.endChapter; a++) {
        arrayTryEnter.push(a)
      }
      // Verifica si el capítulo ingresado existe dentro de capítulos individuales
      individualChapters.map((el, i, arr) => {
        if(array.includes(number)) {
          this.textShow = `<strong>El capítulo ${number} está incluído en capítulos individuales.</strong>`
          this.messageExist = true
          this.validInput(number)
        }
      })
      let newArray = []
      arrayTryEnter.forEach((e, i, arr) => {
        if(array[i]) {
          if(arr.includes(Number(array[i]))) {
            newArray.push(array[i])
            // console.log(array[i], 'si')
          }
        }
      })
      arrayTryEnter.map((e, i, arr) => {
        if(array[i]) {
          if(arr.includes(Number(array[i]))) {
            this.showButtonEdit = false
            this.textShow = `<strong>El capítulo ${newArray.sort()} está incluído en capítulos individuales.</strong>`
            this.messageExist = true
            this.validInput(number)
          }
        }
      })
    },
    editRanges (season, index) {
      this.positionEdit = index
      // console.log(index)
      this.indexRange = index
      this.showButtonEdit = true
      this.initialChapter = this.material.videoCutting[season - 1].chapterRanges[index].startChapter
      this.endChapter = this.material.videoCutting[season - 1].chapterRanges[index].finalChapter
      this.controllerModal = true
    },
    updateRange (season) {
      this.unlockEdit = true
      this.material.videoCutting[season - 1].chapterRanges[this.indexRange].startChapter = this.initialChapter
      this.material.videoCutting[season - 1].chapterRanges[this.indexRange].finalChapter = this.endChapter
      this.initialChapter = ''
      this.endChapter = ''
      this.showButtonEdit = false
      this.controllerModal = false
      // console.log(this.material.videoCutting[season - 1].chapterRanges[this.indexRange])
    },
    editIndiChapter (season, index) {
      this.indexIndiChapters = index
      this.showButtonEdit2 = true
      this.indiChapter = this.material.videoCutting[season - 1].individualChapters[index].chapter
    },
    updateIndiChapters (season) {
      this.unlockEdit = true
      this.material.videoCutting[season - 1].individualChapters[this.indexIndiChapters].chapter = this.indiChapter
      this.indiChapter = ''
      this.showButtonEdit2 = false
      // console.log(this.material.videoCutting[season - 1].individualChapters[this.indexIndiChapters])
    },
    removElement (season, index, item) {
      this.unlockEdit = true
      this.material.videoCutting[season - 1][item].splice(index, 1)

      const isRemoveAll = (value) => {
        return value = this.material.videoCutting[season - 1][item].length == 0 ? false : value
      }
      if(this.activeName == "rangers") {
        this.showButtonEdit = isRemoveAll(this.showButtonEdit)
      } else if(this.activeName == "capsIndividual") {
        this.showButtonEdit2 = isRemoveAll(this.showButtonEdit2)
      }
    },
    /**Al dar enter genera la cantidad de cortes con los tiempos correspondientes en el caso de rangos y capitulo individual
    * @param {Number} season - tempoarada del capitulo
    * @param {Number} index - Posicion del capitulo o rango que se asignaran los cortes
    * @param {String} item - Cadena que difrencia si sera cortes de rango o capitulo individual
    */
    makeCutSpecific (season, index, item) {
      let artisticDuration = this.material.videoCutting[season - 1].artisticDuration // Durac. artística general
      let numberOfCuts = this.material.videoCutting[season - 1][item][index].numberOfCuts
      let timeOfCut = this.material.videoCutting[season - 1][item][index].timeOfCut

      if (numberOfCuts !== '' && timeOfCut !== '') {
        this.disableCreateButton = false // Habilitar botón crear

        this.material.videoCutting[season - 1][item][index].cuts = []
        var numberCuts = Number(numberOfCuts)
        var timeCut = timeOfCut
        var durationTotal = ''

        for (var i = 0; i < numberCuts; i++) {
          // Tiempo inicio de corte
          if (i === 0) {
            // var tci = '00:10:00'
            let arrTimeSec = artisticDuration.split(':')
            let sumTimeSec = (Number(arrTimeSec[0]*60) *60) + Number(arrTimeSec[1]*60)
            let second = '00'
            let hour = '00'
            let minute = '00'
            let cutTime = ''
            
            if(sumTimeSec<900){
              // SI LA DURACION ES MENOR A 15MIN
              minute = Math.floor((sumTimeSec / 2)/60)
              if(minute<10){
                minute = '0' + minute 
              }
              cutTime = hour + ':' + minute + ':' + second
            } else {
              cutTime = '00:10:00'
            }

            var tci = cutTime
          } else {
            let timeInit = i*10 + 20
            let timeInitSec = (Number(timeInit) * 60)
            var horInitSpecific = Math.floor(timeInitSec / 3600)
            if(horInitSpecific < 10){
              horInitSpecific = '0'+ String(horInitSpecific)
            }
            var minInitSpecific = Math.floor((timeInitSec - (horInitSpecific * 3600)) / 60)
            if(minInitSpecific < 10){
              minInitSpecific = '0'+ String(minInitSpecific)
            }
            var secInitSpecific = timeInitSec - (horInitSpecific * 3600) - (minInitSpecific * 60)
            if(secInitSpecific < 10){
              secInitSpecific = '0'+ String(secInitSpecific)
            }
            var tci = horInitSpecific + ':' + minInitSpecific + ':' + secInitSpecific
            let gettingCuts = this.material.videoCutting[season - 1][item][index].cuts
            const previousCut = gettingCuts[gettingCuts.length -1]
            // VALIDAR QUE EL TIEMPO DE INICIO DEL CORTE ACTUAL NO SEA MENOR AL TIEMPO DE CORTE FINAL
            if(previousCut.end >= tci){
              this.validateCutInit(i)
              return false
            }
          
          }

          //Validar si los cortes superan la duracion del material
          var sepA = artisticDuration.indexOf(':')
          var sepB = artisticDuration.lastIndexOf(':')
          var horArtisticSpecific = artisticDuration.substr(0, sepA)
          var minArtisticSpecific = artisticDuration.substr(sepA + 1, sepB - sepA - 1)
          var secArtisticSpecific = artisticDuration.substr(sepB + 1)

          if(horInitSpecific>=horArtisticSpecific){
            if(horInitSpecific>horArtisticSpecific){
              this.validateCuts()
              return false
            } else if(horInitSpecific==horArtisticSpecific){
              if(minInitSpecific > minArtisticSpecific){
                this.validateCuts()
                return false
              }
            }
          }

          // Duración de corte
          timeCut = timeCut.length === 1 ? '0' + timeCut : timeCut
          var duration = '00:' + timeCut + ':00'
          durationTotal = addTimes(durationTotal, duration)          

          // Tiempo fin de corte
          var tcf = addTimes(tci, duration)

          // REEMPLAZA LOS CORTES CREADOS
          // VALIDA SI EL TIEMPO DE CORTE FINAL NO EXCEDE LA DURACION DEL CAPITULO
          let totalDuration = artisticDuration

          if(tcf > totalDuration){
            this.validateCuts()
            return false
          } else {
            this.material.videoCutting[season - 1][item][index].cuts.push({'id': i+1, 'start': tci, 'duration': duration, 'end': tcf})
          }

          // Restar tiempo a Duración artística
          this.material.videoCutting[season - 1][item][index].artisticDuration = restTimes(artisticDuration, durationTotal)
          // Limpiar inputs
          this.material.videoCutting[season - 1][item][index].numberOfCuts = ''
          this.material.videoCutting[season - 1][item][index].timeOfCut = ''
        }

      } else{
        this.disableCreateButton = true // Deshabilitar botón crear
      }

    },
    /**Al dar enter genera la cantidad de cortes con los tiempos correspondientes en el caso de rangos y capitulo individual
    * @param {Number} season - tempoarada del capitulo
    * @param {Number} index - Posicion del capitulo o rango que se asignaran los cortes
    * @param {String} index2 - Posicion del corte
    * @param {String} item - Cadena que difrencia si sera cortes de rango o capitulo individual
    */
    calculateTimeEndSpecific (season, index, index2, item) {
      let artisticDuration = this.material.videoCutting[season - 1].artisticDuration // Durac. artística general
      let arrCuts = this.material.videoCutting[season - 1][item][index].cuts // Array donde se almacenan los cortes (objetos)

      if(arrCuts[index2] !== undefined){
        var start = arrCuts[index2].start
        var duration = arrCuts[index2].duration
        var end = arrCuts[index2].end
        var newDurationTotal = ''
        
        if (start.indexOf(':') === 2 && start.lastIndexOf(':') === 2) {
          start = arrCuts[index2].start + ':00'
        } 

        if (duration.indexOf(':') === 2 && duration.lastIndexOf(':') === 2) {
          duration = arrCuts[index2].duration + ':00'
        }

        // SOLO ENTRA A VALIDAR SI EL CORTE SELECCIONADO NO ES EL 1ER CORTE
        if(index2>0){
          const previousCut = arrCuts[index2-1]
          const cutSelect = arrCuts[index2]
          
          if (cutSelect.start.indexOf(':') === 2 && cutSelect.start.lastIndexOf(':') === 2) {
            cutSelect.start = cutSelect.start + ':00'
          }
          
          // VALIDAR QUE EL TIEMPO DE INICIO DEL CORTE ACTUAL NO SEA MENOR AL TIEMPO DE CORTE FINAL
          if(previousCut.end >= cutSelect.start){
            arrCuts.splice(index2, 1)
            this.validateCutInit(index2)
            return false
          }
        }
        
        let totalDuration = artisticDuration
        const timeInit = start.split(':')
        const horInit = timeInit[0]
        const minInit = timeInit[1]
        let sep1 = totalDuration.indexOf(':')
        let sep2 = totalDuration.lastIndexOf(':')
        let horArtistic = totalDuration.substr(0, sep1)
        let minArtistic = totalDuration.substr(sep1 + 1, sep2 - sep1 - 1)
        let secArtistic = totalDuration.substr(sep2 + 1)

        if(horInit>=horArtistic){
          if(horInit>horArtistic){
            // MUESTRA MODAL CORTES EXCEDEN DURACION 
            this.validateCuts()
            // COMO NO SE VA A GUARDAR EN LA DATA EL CORTE EXCEDENTE, DEBERIA BORRARLO AUTOMATICAMENTE
            arrCuts.splice(index2, 1)
            return false
          } else if(horInit==horArtistic){
            if(minInit >= minArtistic){
              // MUESTRA MODAL CORTES EXCEDEN DURACION
              this.validateCuts()
              // COMO NO SE VA A GUARDAR EN LA DATA EL CORTE EXCEDENTE, DEBERIA BORRARLO AUTOMATICAMENTE
              arrCuts.splice(index2, 1)
              return false
            }
          }
        }
        // CALCULA LA DURACION FINAL DEL CORTE
        end = addTimes(start, duration)
        // VALIDA SI EL TIEMPO DE CORTE FINAL NO EXCEDE LA DURACION DEL CAPITULO
        if(end > totalDuration){
          this.validateCuts()
          arrCuts.splice(index2, 1)
        } else {
          // ACTUALIZA EL CORTE YA CON SU DURACION FINAL
          arrCuts.splice(index2, 1, {'id': index2+1, 'start': start, 'duration': duration, 'end': end})
        }
        for (var i = 0; i < arrCuts.length; i++) {
          newDurationTotal = addTimes(newDurationTotal, arrCuts[i].duration)
        }
        // Restar tiempo a Duración artística
        this.material.videoCutting[season - 1][item][index].artisticDuration = restTimes(artisticDuration, newDurationTotal)
        // Vigilar Duración Artística y activar alert
        if(JSON.stringify(this.material.videoCutting) !== JSON.stringify(this.cutsMaterialInitialValue)){
          this.unlockEdit = true
        }
      }
    },
    /**Elimina uno de los cortes que ya se han generado en lista de cortes por rango o individual
    * @param {Number} season - tempoarada del capitulo
    * @param {Number} index - Posicion del capitulo o rango que se asignaran los cortes
    * @param {String} index2 - Posicion del corte
    * @param {String} item - Cadena que difrencia si sera cortes de rango o capitulo individual
    */
    removeCutSpecific (season, index, index2, item) {
      let artisticDuration = this.material.videoCutting[season - 1].artisticDuration // Durac. artística general
      let arrCuts = this.material.videoCutting[season - 1][item][index].cuts // Array donde se almacenan los cortes (objetos)
      arrCuts.splice(index2, 1)
      var newDurationTotal = ''
      for (var i = 0; i < arrCuts.length; i++) {
        newDurationTotal = addTimes(newDurationTotal, arrCuts[i].duration)
        arrCuts[i].id = i + 1
      }
      // Restar tiempo a Duración artística
      this.material.videoCutting[season - 1][item][index].artisticDuration = restTimes(artisticDuration, newDurationTotal)
      // Vigilar Duración Artística y activar alert
      if(JSON.stringify(this.material.videoCutting) !== JSON.stringify(this.cutsMaterialInitialValue)){
        this.unlockEdit = true
      }
    },
    /**Agrega un corte entre los que ya se han generado en lista de cortes por rango o individual
    * @param {Number} season - tempoarada del capitulo
    * @param {Number} index - Posicion del capitulo o rango que se asignaran los cortes
    * @param {String} index2 - Posicion del corte
    * @param {String} item - Cadena que difrencia si sera cortes de rango o capitulo individual
    */
    addCutsSpecific (season, index, index2, item) {
      let arrCuts = this.material.videoCutting[season - 1][item][index].cuts // Array donde se almacenan los cortes (objetos)

      arrCuts.map((el, i, arr) => {
        if (i == index2) {
          arr.splice(i + 1, 0, {'id': i+2, 'start': '00:00:00', 'duration': '00:00:00', 'end': '00:00:00'});
        } 
      });

      for (var i = 0; i < arrCuts.length; i++) {
        arrCuts[i].id = i + 1
      }
    },
    clone (original) {
      var element = {}
      for (var key in original) {
        if (original.hasOwnProperty(key)) {
          element[key] = original[key]
        }
      }
      return element
    },
    /***/
    changeAllRanks (season, index) {
      let chapterRanges = this.material.videoCutting[season - 1].chapterRanges
      let cutsToCopy = this.material.videoCutting[season - 1].chapterRanges[index].cuts
      let applyAllRanks = this.material.videoCutting[season - 1].chapterRanges[index].applyAllRanks

      if (applyAllRanks === true) {
        chapterRanges.map((ella, i, arr) => {
          ella.artisticDuration = this.material.videoCutting[season - 1].chapterRanges[index].artisticDuration
          ella.cuts = []
          // Realizar una copia de cada objeto del array de cortes 
          cutsToCopy.map((el, i, arr) => {
            ella.cuts.push(this.clone(el))
          })

          if(i !== index){
            ella.applyAllRanks = false
          }
        })
      }
      this.unlockEdit = true
    },
    changeAllIndiChapters (season, index) {
      let individualChapters = this.material.videoCutting[season - 1].individualChapters
      let cutsToCopy = this.material.videoCutting[season - 1].individualChapters[index].cuts
      let applyAllIndiChapters = this.material.videoCutting[season - 1].individualChapters[index].applyAllIndiChapters

      if (applyAllIndiChapters === true) {
        individualChapters.map((ella, i, arr) => {
          ella.artisticDuration = this.material.videoCutting[season - 1].individualChapters[index].artisticDuration
          ella.cuts = []
          // Realizar una copia de cada objeto del array de cortes 
          cutsToCopy.map((el, i, arr) => {
            ella.cuts.push(this.clone(el))
          })
        })
      }
    },
    isNumber (evt) {
      evt = (evt) ? evt : window.event;
      var charCode = (evt.which) ? evt.which : evt.keyCode;
      if ((charCode > 31 && (charCode < 48 || charCode > 57)) && charCode !== 46) {
        evt.preventDefault();
      } else {
        return true;
      }      
    },
    validNumber(val) {
      if(Number(val) > 59) {
        this.timeOfCut = ''
      }
    },
    validateForTypeCuts() {
      const {chapterRanges, individualChapters } = this.material.videoCutting[0]
      
      if(individualChapters.length > 0 && chapterRanges.length > 0) {
        this.capTypeCut = true
        this.textShowTypeCut = this.concatText('firstOption', 'los cortes por rangos y </br> capítulos individuales.')
      } else if(chapterRanges.length > 0) {
        this.capTypeCut = true
        this.textShowTypeCut = this.concatText('firstOption', 'los cortes por rangos.')
      } else if(individualChapters.length > 0) {
        this.capTypeCut = true
        this.textShowTypeCut = this.concatText('firstOption', 'capítulos individuales.')
      }
    },
    validateForSelectAllChapter(value) {
      const { allChapters } = this.material.videoCutting[0]
      let text = value == 'capsIndividual' ? 'por capítulos individuales' : 'por rangos'
      if(allChapters.cuts.length > 0) {
        this.capTypeCut = true
        this.textShowTypeCut = this.concatText('secondOption', text)
      }
    },
    validInput(number) {
      this.initialChapter = this.endChapter = this.initialChapter == Number(number) || this.initialChapter == '' || this.endChapter == Number(number) || this.endChapter == '' ? '' : Number(number)
    },
    cleanInfo() {
      if(this.activeName == "rangers" || this.activeName == "capsIndividual") {
        this.material.videoCutting[0].allChapters.cuts = []
      } else {
        this.material.videoCutting[0].individualChapters = []
        this.material.videoCutting[0].chapterRanges = []
      }
      this.capTypeCut = false
    },
    cancelModal(){
      this.numberOfCuts = this.timeOfCut = this.indiChapter = ''
      this.capTypeCut = false    
    },
    isShowModal(type, value) {
      if (type == 'allChapters') {
        this.validateForTypeCuts() //Modal si lleno información entre rangos o por cada capitulos y decido ir a todos los capitulos aparece este modal
      } else {
        this.validateForSelectAllChapter(value) //Modal si lleno los cortes para todos los capítulos y decido ir a por rangos o individuales aparece ese modal.
      }
      
    }, 
    concatText(type, value){
      if(type == 'firstOption') {
        return `Si ingresas los cortes a todos los capítulos, se <strong>eliminarán</strong> ${value}.`
      } else {
        return `Si ingresas los cortes ${value}, se <strong>eliminarán</strong> los cortes para todos los capítulos.`
      }
      
    },
    getCutsData(value) {
      let { stringMaterialType, numChapters, infoSupport } = value
      let conditional = stringMaterialType ? stringMaterialType.toLowerCase() : ''
      if(['afiliación-televisa',"afiliación/televisa"].includes(conditional)) {
        /*Con capítulos */
        let data
        if(numChapters.length > 0) {
          let {infoByChapter} = numChapters[0]
          let capsWithSupport = []
          infoByChapter.map((e) => {
            const {typeStorage, storage} = e
            if(typeStorage && typeStorage !== '' && storage && storage !== '') {
              capsWithSupport.push(e)
            }
          })
          data = capsWithSupport
        } else {
          /*Sin capítulos */
          if(infoSupport && infoSupport.length > 0) {
            let { storages, supportMaterial } = infoSupport[0]
            data = [{
              chapter: 1,
              storages: storages,
              supportMaterial: supportMaterial
            }]
          }
        }
        return data
      }
    },
    /**Trae informacion del contrato en el que esta asignado este material
    * @param {String} value - Codigo del contrato
    * @param {String} codMaterial - Codigo del codigo del material
    */
    async getInfoAboutContract(value, codMaterial) {
      let data, array;
      let response = await HTTP.get(`/contracts/contractCode/${value}`)
      let {contract} = await response.data
      const information = contract[0] && contract[0].admittedMaterials.filter((e)=> e.codMaterial == codMaterial)[0]
      if(information) {
        let {numChapters, codMaterial:material, infoSupport} = information

        let data, array;
        /*Con capítulos */
        if(numChapters.length > 0) {
          let {infoByChapter} = numChapters[0]
          array  = [ ...new Set (infoByChapter.map((e, i) => {
              return {
                chapter: e.chapter,
                storages: e.storages,
                supportMaterial: e.supportMaterial
              }
          }))]
          let prevData = []
          console.log({array})
          if(array && array[0]) {
            array.map((e) => {
              const {storages, supportMaterial} = e
              if(storages && storages !== '' && supportMaterial && supportMaterial.length > 0 && supportMaterial[0].typeStorage && supportMaterial[0].typeStorage !== '') {
                prevData.push(e)
              }
            })
          } else {
            prevData = undefined
          }
          data = prevData
        } else {
          if(infoSupport && infoSupport.arrivalDate) {
            let {storages, supportMaterial} = infoSupport
            array = [ ...new Set (supportMaterial.map((e) => {
                return {
                  chapter: 1,
                  storages: storages,
                  supportMaterial: supportMaterial
                }
            }))]
            data = array && array[0] ? array : undefined
          } else if(infoSupport && infoSupport[0]) {
            let {storages, supportMaterial} = infoSupport[0]
            array = [ ...new Set (supportMaterial.map((e) => {
                return {
                  chapter: 1,
                  storages: storages,
                  supportMaterial: supportMaterial
                }
            }))]
            data = array && array[0] ? array : undefined
          }
        }
        return data
      }
      return data
    }
  },
  destroyed() {
    this.$store.commit('material', {})
  }
}
</script>

<style>
  /* Tabs Style */
  .tabContentStyle.el-tabs--card > .el-tabs__header{
    border-bottom: 0;
  }

  .tabContentStyle.el-tabs--card > .el-tabs__header .el-tabs__item{
    border: 1px solid #FF7333;
    text-align: center;
    font-size: 18px;
    color: #929292;
    font-weight: lighter;
    margin: 0 5px;
    width: 32%;
  }

  .tabContentStyle.el-tabs--card > .el-tabs__header .el-tabs__item:first-child{
    border-left: 1px solid #FF7333;
  }

  .tabContentStyle.el-tabs--card > .el-tabs__header .el-tabs__item.is-active{
    background: #FF7333;
    box-shadow: 0px 3px 6px grey;
    border: 1px solid #FF7333;
  }

  .tabContentStyle.el-tabs--card > .el-tabs__header .el-tabs__nav{
    border: 0;
  }

  .tabContentStyle.el-tabs--card > .el-tabs__header .el-tabs__nav .is-active{
    color: white;
  }
 
  .tabContentStyle .el-tabs__nav.is-top, .tabContentStyle .el-tabs__nav{
    float: none;
    text-align: center;
  }

  .tabContentStyle .el-tabs__nav-wrap, .tabContentStyle .el-tabs__nav-scroll{
    overflow: initial;
  }

  .tabMargin{
    padding: 2rem;
  }
  .el-checkbox.checkSize > .el-checkbox__input > .el-checkbox__inner{
    width: 20px;
    height: 20px;
  }
  .el-checkbox.checkSize > .el-checkbox__input >.el-checkbox__inner::after{
    height: 8px;
    left: 7px;
    top: 3px;
    border: 2px solid #fff;
    border-left: 0;
    border-top: 0;
  }

</style>
